﻿using FluentNHibernate.Cfg;
using FluentNHibernate.Cfg.Db;
using Newtonsoft.Json;
using NHibernate;
using NHibernate.Tool.hbm2ddl;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace ServerExtensionCSharpEmpty1
{




    public class SQLConnecter
    {
        private static ISessionFactory sessionFactory;
        //private static Timer myTimer = new Timer();
        private static readonly log4net.ILog log = log4net.LogManager.GetLogger(System.Reflection.MethodBase.GetCurrentMethod().DeclaringType);
        private static string data = "";
        public static string MyData  
        {
            get 
            { 
                return data;
            }   
            set 
            {
                if (data != value)
                {
                    data = value;
                }

            } 
        }




        public SQLConnecter()
        {        
        }


        public void Do()
        {
            Thread t = new Thread(DoInBackground);
            t.Start();
        }

        public void DoInBackground()
        {
            sessionFactory = CreateSessionFactory();
            try
            {
                MainFN();
            }
            catch (Exception ex)
            {
                log.Info("connecting??????????????? excepction = " + ex.Message);
            }           
        }
        private static ISessionFactory CreateSessionFactory()
        {
            return Fluently.Configure()
                .Database(
                SQLiteConfiguration.Standard
                .UsingFile("projectData.db")
                )
                .Mappings(m =>
                            m.FluentMappings.AddFromAssemblyOf<Data>())
                .ExposeConfiguration(BuildSchema)
                .BuildSessionFactory();
        }

        private static void BuildSchema(NHibernate.Cfg.Configuration config)
        {
            // delete the existing db on each run
            if (File.Exists("projectData.db"))
                File.Delete("projectData.db");

            // this NHibernate tool takes a configuration (with mapping info in)
            // and exports a database schema from it
            new SchemaExport(config)
              .Create(false, true);
        }


        private static void MainFN()
        {
            using (var session = sessionFactory.OpenSession())
            {
                using (var transaction = session.BeginTransaction())
                {
                    Data[] myDataInstance = new Data[12];
                    for (int i = 0; i < 12; i++)
                    {
                        myDataInstance[i] = new Data();
                        myDataInstance[i].Test1 = "Example Data " + (i + 1).ToString();
                        myDataInstance[i].Test2 = i + 11;
                        myDataInstance[i].Test3 = (i % 2 == 0);
                        myDataInstance[i].CurrentTime = DateTime.Now.ToString();
                        myDataInstance[i].ComboBox = i % 4 ;
                        session.SaveOrUpdate(myDataInstance[i]);
                    }
                    MyData = JsonConvert.SerializeObject(myDataInstance, Formatting.Indented, new JsonSerializerSettings
                    {
                        ReferenceLoopHandling = ReferenceLoopHandling.Ignore
                    });
                    transaction.Commit();
                }
            }
        }

        public  void DeleteLine(int index)
        {
            using (var session = sessionFactory.OpenSession())
            {
                using (var transaction = session.BeginTransaction())
                {
                    List<Data> storesAll = (List<Data>)session.QueryOver<Data>().List<Data>();
                    if (storesAll.Count > 0)
                    {
                        var sorefromlist = storesAll[index];

                        var store = session.Get<Data>(sorefromlist.Id);
                        session.Delete(store);
                    }
                    session.Flush();
                    transaction.Commit();
                }
            }
            ReadData();
        }



        public void ReadData()
        {
            try
            {
                using (var session = sessionFactory.OpenSession())
                {
                    using (var transaction = session.BeginTransaction())
                    {
                        var list = session.QueryOver<Data>().List();
                        MyData = JsonConvert.SerializeObject(list, Formatting.Indented, new JsonSerializerSettings
                        {
                            ReferenceLoopHandling = ReferenceLoopHandling.Ignore
                        });
                    }
                }
            }
            catch (Exception ex)
            {
            }
        }


        public void AddItem(string test1, int test2, bool truefalse, int comb)
        {
            try
            {
                using (var session = sessionFactory.OpenSession())
                {
                    using (var transaction = session.BeginTransaction())
                    {
                        List<Data> list = (List<Data>)session.QueryOver<Data>().List();
                        Data d = new Data();
                        d.Test1 = test1;
                        d.Test2 = test2;
                        d.Test3 = truefalse;
                        d.CurrentTime = DateTime.Now.ToString();
                        d.ComboBox = comb;
                        list.Add(d);
                        session.SaveOrUpdate(d);
                        session.Flush();
                        transaction.Commit();
                    }
                }
            }
            catch (Exception ex)
            {
            }
            ReadData();
        }



    }
}
